<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for List ServiceType
 * @subpackage Services
 */
class _List extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named listDatabase
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListDatabase $parameters
     * @return \StructType\ListDatabaseResponse|bool
     */
    public function listDatabase(\StructType\ListDatabase $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listDatabase($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listFilestore
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListFilestore $parameters
     * @return \StructType\ListFilestoreResponse|bool
     */
    public function listFilestore(\StructType\ListFilestore $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listFilestore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAllFilestore
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListAllFilestore $parameters
     * @return \StructType\ListAllFilestoreResponse|bool
     */
    public function listAllFilestore(\StructType\ListAllFilestore $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listAllFilestore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListServer $parameters
     * @return \StructType\ListServerResponse|bool
     */
    public function listServer(\StructType\ListServer $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listServer($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAllDatabase
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListAllDatabase $parameters
     * @return \StructType\ListAllDatabaseResponse|bool
     */
    public function listAllDatabase(\StructType\ListAllDatabase $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listAllDatabase($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAllMaintenanceReason
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListAllMaintenanceReason $parameters
     * @return \StructType\ListAllMaintenanceReasonResponse|bool
     */
    public function listAllMaintenanceReason(\StructType\ListAllMaintenanceReason $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listAllMaintenanceReason($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listAllServer
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListAllServer $parameters
     * @return \StructType\ListAllServerResponse|bool
     */
    public function listAllServer(\StructType\ListAllServer $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listAllServer($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named listMaintenanceReason
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ListMaintenanceReason $parameters
     * @return \StructType\ListMaintenanceReasonResponse|bool
     */
    public function listMaintenanceReason(\StructType\ListMaintenanceReason $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->listMaintenanceReason($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\ListAllDatabaseResponse|\StructType\ListAllFilestoreResponse|\StructType\ListAllMaintenanceReasonResponse|\StructType\ListAllServerResponse|\StructType\ListDatabaseResponse|\StructType\ListFilestoreResponse|\StructType\ListMaintenanceReasonResponse|\StructType\ListServerResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
