<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changeFilestore StructType
 * @subpackage Structs
 */
class ChangeFilestore extends AbstractStructBase
{
    /**
     * The fstore
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Filestore
     */
    public $fstore;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for changeFilestore
     * @uses ChangeFilestore::setFstore()
     * @uses ChangeFilestore::setAuth()
     * @param \StructType\Filestore $fstore
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\Filestore $fstore = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setFstore($fstore)
            ->setAuth($auth);
    }
    /**
     * Get fstore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Filestore|null
     */
    public function getFstore()
    {
        return isset($this->fstore) ? $this->fstore : null;
    }
    /**
     * Set fstore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Filestore $fstore
     * @return \StructType\ChangeFilestore
     */
    public function setFstore(\StructType\Filestore $fstore = null)
    {
        if (is_null($fstore) || (is_array($fstore) && empty($fstore))) {
            unset($this->fstore);
        } else {
            $this->fstore = $fstore;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\ChangeFilestore
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChangeFilestore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
