<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckedDatabases StructType
 * @subpackage Structs
 */
class CheckedDatabases extends AbstractStructBase
{
    /**
     * The needsupdate
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Database[]
     */
    public $needsupdate;
    /**
     * The blocked
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Database[]
     */
    public $blocked;
    /**
     * The outdated
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Database[]
     */
    public $outdated;
    /**
     * Constructor method for CheckedDatabases
     * @uses CheckedDatabases::setNeedsupdate()
     * @uses CheckedDatabases::setBlocked()
     * @uses CheckedDatabases::setOutdated()
     * @param \StructType\Database[] $needsupdate
     * @param \StructType\Database[] $blocked
     * @param \StructType\Database[] $outdated
     */
    public function __construct(array $needsupdate = array(), array $blocked = array(), array $outdated = array())
    {
        $this
            ->setNeedsupdate($needsupdate)
            ->setBlocked($blocked)
            ->setOutdated($outdated);
    }
    /**
     * Get needsupdate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Database[]|null
     */
    public function getNeedsupdate()
    {
        return isset($this->needsupdate) ? $this->needsupdate : null;
    }
    /**
     * Set needsupdate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Database[] $needsupdate
     * @return \StructType\CheckedDatabases
     */
    public function setNeedsupdate(array $needsupdate = array())
    {
        foreach ($needsupdate as $checkedDatabasesNeedsupdateItem) {
            // validation for constraint: itemType
            if (!$checkedDatabasesNeedsupdateItem instanceof \StructType\Database) {
                throw new \InvalidArgumentException(sprintf('The needsupdate property can only contain items of \StructType\Database, "%s" given', is_object($checkedDatabasesNeedsupdateItem) ? get_class($checkedDatabasesNeedsupdateItem) : gettype($checkedDatabasesNeedsupdateItem)), __LINE__);
            }
        }
        if (is_null($needsupdate) || (is_array($needsupdate) && empty($needsupdate))) {
            unset($this->needsupdate);
        } else {
            $this->needsupdate = $needsupdate;
        }
        return $this;
    }
    /**
     * Add item to needsupdate value
     * @throws \InvalidArgumentException
     * @param \StructType\Database $item
     * @return \StructType\CheckedDatabases
     */
    public function addToNeedsupdate(\StructType\Database $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Database) {
            throw new \InvalidArgumentException(sprintf('The needsupdate property can only contain items of \StructType\Database, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->needsupdate[] = $item;
        return $this;
    }
    /**
     * Get blocked value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Database[]|null
     */
    public function getBlocked()
    {
        return isset($this->blocked) ? $this->blocked : null;
    }
    /**
     * Set blocked value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Database[] $blocked
     * @return \StructType\CheckedDatabases
     */
    public function setBlocked(array $blocked = array())
    {
        foreach ($blocked as $checkedDatabasesBlockedItem) {
            // validation for constraint: itemType
            if (!$checkedDatabasesBlockedItem instanceof \StructType\Database) {
                throw new \InvalidArgumentException(sprintf('The blocked property can only contain items of \StructType\Database, "%s" given', is_object($checkedDatabasesBlockedItem) ? get_class($checkedDatabasesBlockedItem) : gettype($checkedDatabasesBlockedItem)), __LINE__);
            }
        }
        if (is_null($blocked) || (is_array($blocked) && empty($blocked))) {
            unset($this->blocked);
        } else {
            $this->blocked = $blocked;
        }
        return $this;
    }
    /**
     * Add item to blocked value
     * @throws \InvalidArgumentException
     * @param \StructType\Database $item
     * @return \StructType\CheckedDatabases
     */
    public function addToBlocked(\StructType\Database $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Database) {
            throw new \InvalidArgumentException(sprintf('The blocked property can only contain items of \StructType\Database, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->blocked[] = $item;
        return $this;
    }
    /**
     * Get outdated value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Database[]|null
     */
    public function getOutdated()
    {
        return isset($this->outdated) ? $this->outdated : null;
    }
    /**
     * Set outdated value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Database[] $outdated
     * @return \StructType\CheckedDatabases
     */
    public function setOutdated(array $outdated = array())
    {
        foreach ($outdated as $checkedDatabasesOutdatedItem) {
            // validation for constraint: itemType
            if (!$checkedDatabasesOutdatedItem instanceof \StructType\Database) {
                throw new \InvalidArgumentException(sprintf('The outdated property can only contain items of \StructType\Database, "%s" given', is_object($checkedDatabasesOutdatedItem) ? get_class($checkedDatabasesOutdatedItem) : gettype($checkedDatabasesOutdatedItem)), __LINE__);
            }
        }
        if (is_null($outdated) || (is_array($outdated) && empty($outdated))) {
            unset($this->outdated);
        } else {
            $this->outdated = $outdated;
        }
        return $this;
    }
    /**
     * Add item to outdated value
     * @throws \InvalidArgumentException
     * @param \StructType\Database $item
     * @return \StructType\CheckedDatabases
     */
    public function addToOutdated(\StructType\Database $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Database) {
            throw new \InvalidArgumentException(sprintf('The outdated property can only contain items of \StructType\Database, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->outdated[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckedDatabases
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
