<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createMaintenanceReason StructType
 * @subpackage Structs
 */
class CreateMaintenanceReason extends AbstractStructBase
{
    /**
     * The reason
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MaintenanceReason
     */
    public $reason;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for createMaintenanceReason
     * @uses CreateMaintenanceReason::setReason()
     * @uses CreateMaintenanceReason::setAuth()
     * @param \StructType\MaintenanceReason $reason
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\MaintenanceReason $reason = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setReason($reason)
            ->setAuth($auth);
    }
    /**
     * Get reason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MaintenanceReason|null
     */
    public function getReason()
    {
        return isset($this->reason) ? $this->reason : null;
    }
    /**
     * Set reason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\MaintenanceReason $reason
     * @return \StructType\CreateMaintenanceReason
     */
    public function setReason(\StructType\MaintenanceReason $reason = null)
    {
        if (is_null($reason) || (is_array($reason) && empty($reason))) {
            unset($this->reason);
        } else {
            $this->reason = $reason;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\CreateMaintenanceReason
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateMaintenanceReason
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
