<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createSchema StructType
 * @subpackage Structs
 */
class CreateSchema extends AbstractStructBase
{
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * The optDBId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $optDBId;
    /**
     * Constructor method for createSchema
     * @uses CreateSchema::setAuth()
     * @uses CreateSchema::setOptDBId()
     * @param \StructType\Credentials $auth
     * @param int $optDBId
     */
    public function __construct(\StructType\Credentials $auth = null, $optDBId = null)
    {
        $this
            ->setAuth($auth)
            ->setOptDBId($optDBId);
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\CreateSchema
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Get optDBId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getOptDBId()
    {
        return isset($this->optDBId) ? $this->optDBId : null;
    }
    /**
     * Set optDBId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $optDBId
     * @return \StructType\CreateSchema
     */
    public function setOptDBId($optDBId = null)
    {
        // validation for constraint: int
        if (!is_null($optDBId) && !is_numeric($optDBId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($optDBId)), __LINE__);
        }
        if (is_null($optDBId) || (is_array($optDBId) && empty($optDBId))) {
            unset($this->optDBId);
        } else {
            $this->optDBId = $optDBId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateSchema
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
