<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MaintenanceReason StructType
 * @subpackage Structs
 */
class MaintenanceReason extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $id;
    /**
     * The idset
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var bool
     */
    public $idset;
    /**
     * The text
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $text;
    /**
     * The textset
     * Meta informations extracted from the WSDL
     * - form: qualified
     * - minOccurs: 0
     * @var bool
     */
    public $textset;
    /**
     * Constructor method for MaintenanceReason
     * @uses MaintenanceReason::setId()
     * @uses MaintenanceReason::setIdset()
     * @uses MaintenanceReason::setText()
     * @uses MaintenanceReason::setTextset()
     * @param int $id
     * @param bool $idset
     * @param string $text
     * @param bool $textset
     */
    public function __construct($id = null, $idset = null, $text = null, $textset = null)
    {
        $this
            ->setId($id)
            ->setIdset($idset)
            ->setText($text)
            ->setTextset($textset);
    }
    /**
     * Get id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : null;
    }
    /**
     * Set id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $id
     * @return \StructType\MaintenanceReason
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->id);
        } else {
            $this->id = $id;
        }
        return $this;
    }
    /**
     * Get idset value
     * @return bool|null
     */
    public function getIdset()
    {
        return $this->idset;
    }
    /**
     * Set idset value
     * @param bool $idset
     * @return \StructType\MaintenanceReason
     */
    public function setIdset($idset = null)
    {
        // validation for constraint: boolean
        if (!is_null($idset) && !is_bool($idset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($idset)), __LINE__);
        }
        $this->idset = $idset;
        return $this;
    }
    /**
     * Get text value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getText()
    {
        return isset($this->text) ? $this->text : null;
    }
    /**
     * Set text value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $text
     * @return \StructType\MaintenanceReason
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($text)), __LINE__);
        }
        if (is_null($text) || (is_array($text) && empty($text))) {
            unset($this->text);
        } else {
            $this->text = $text;
        }
        return $this;
    }
    /**
     * Get textset value
     * @return bool|null
     */
    public function getTextset()
    {
        return $this->textset;
    }
    /**
     * Set textset value
     * @param bool $textset
     * @return \StructType\MaintenanceReason
     */
    public function setTextset($textset = null)
    {
        // validation for constraint: boolean
        if (!is_null($textset) && !is_bool($textset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($textset)), __LINE__);
        }
        $this->textset = $textset;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MaintenanceReason
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
